package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:气质类型测试
 * @date 2021/7/20 15:55
 */
public class TTTScale extends BaseScale{

    public TTTScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("TTTSCALE.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.TTTScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //胆汁质得分
        int score1 = 0;
        //多血质得分
        int score2 = 0;
        //粘液质得分
        int score3 = 0;
        //抑郁质得分
        int score4 = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (i == 1 || i == 5 || i == 8 || i == 13 || i == 16 || i == 20 || i == 26 || i == 30 || i == 35 || i == 37 || i == 41 || i == 47 || i ==49 || i == 53 || i == 57){
                if (jsonObject1.getString("checkItems").equals("完全一致")) {
                    score1 += 2;
                } else if (jsonObject1.getString("checkItems").equals("比较一致")) {
                    score1 += 1;
                } else if (jsonObject1.getString("checkItems").equals("不太一致")) {
                    score1 -= 1;
                } else if (jsonObject1.getString("checkItems").equals("很不一致")) {
                    score1 -= 2;
                }
            }else if (i == 3 || i == 7 || i == 10 || i == 15 || i == 18 || i == 22 || i == 24 || i == 28 || i == 33 || i == 39 || i == 43 || i == 45 || i ==51 || i == 55 || i == 59){
                if (jsonObject1.getString("checkItems").equals("完全一致")) {
                    score2 += 2;
                } else if (jsonObject1.getString("checkItems").equals("比较一致")) {
                    score2 += 1;
                } else if (jsonObject1.getString("checkItems").equals("不太一致")) {
                    score2 -= 1;
                } else if (jsonObject1.getString("checkItems").equals("很不一致")) {
                    score2 -= 2;
                }
            }else if (i == 0 || i == 6 || i == 9 || i == 12 || i == 17 || i == 21 || i == 25 || i == 29 || i == 32 || i == 38 || i == 42 || i == 44 || i ==48 || i == 54 || i == 56){
                if (jsonObject1.getString("checkItems").equals("完全一致")) {
                    score3 += 2;
                } else if (jsonObject1.getString("checkItems").equals("比较一致")) {
                    score3 += 1;
                } else if (jsonObject1.getString("checkItems").equals("不太一致")) {
                    score3 -= 1;
                } else if (jsonObject1.getString("checkItems").equals("很不一致")) {
                    score3 -= 2;
                }
            }else {
                if (jsonObject1.getString("checkItems").equals("完全一致")) {
                    score4 += 2;
                } else if (jsonObject1.getString("checkItems").equals("比较一致")) {
                    score4 += 1;
                } else if (jsonObject1.getString("checkItems").equals("不太一致")) {
                    score4 -= 1;
                } else if (jsonObject1.getString("checkItems").equals("很不一致")) {
                    score4 -= 2;
                }
            }
        }
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("胆汁质得分", String.valueOf(score1));
        resultJson.put("胆汁质得分", String.valueOf(score1));
        resultMap.put("多血质得分", String.valueOf(score2));
        resultJson.put("多血质得分", String.valueOf(score2));
        resultMap.put("粘液质得分", String.valueOf(score3));
        resultJson.put("粘液质得分", String.valueOf(score3));
        resultMap.put("抑郁质得分", String.valueOf(score4));
        resultJson.put("抑郁质得分", String.valueOf(score4));

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_TTT);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
